=== debian/changelog ===
ta-lib (0.6.4-2) unstable; urgency=medium

  * source upload
  * debian/coypright: update

 -- Thorsten Alteholz <debian@alteholz.de>  Fri, 20 Jun 2025 19:04:56 +0200

ta-lib (0.6.4-1) unstable; urgency=medium

  * initial upload (Closes: #437177)
    This version only contains the C/C++ libraries. Other languages are
    not yet supported.

 -- Thorsten Alteholz <debian@alteholz.de>  Thu, 19 Jun 2025 20:04:56 +0200
