=== debian/control ===
Source: ta-lib
Section: libs
Priority: optional
Maintainer: Thorsten Alteholz <debian@alteholz.de>
Build-Depends: debhelper-compat (= 13)
Standards-Version: 4.7.2
Homepage: http://www.ta-lib.org/
Vcs-Browser: https://salsa.debian.org/alteholz/ta-lib
Vcs-Git: https://salsa.debian.org/alteholz/ta-lib.git
Rules-Requires-Root: no

Package: ta-lib-dev
Section: libdevel
Architecture: any
Depends: libta-lib0 (= ${binary:Version}), libc6-dev | libc-dev, ${misc:Depends}
Description: library for the technical analysis of financial market data - dev files
 TA-Lib is a set of libraries providing common functions for the technical
 analysis of financial market data. It contains over 130 TA indicators and
 offers candlestick pattern recognition.
 .
 This package contains the C header files and development libraries.

Package: libta-lib0
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: library for the technical analysis of financial market data - runtime library
 TA-Lib is a set of libraries providing common functions for the technical
 analysis of financial market data. It contains over 130 TA indicators and
 offers candlestick pattern recognition.
 .
 This package contains the runtime library.

## does not work yet
#Package: ta-lib-tools
#Architecture: any
#Section: utils
#Depends: ${shlibs:Depends}, ${misc:Depends}
#Description: library for the technical analysis of financial market data - tools
# TA-Lib is a set of libraries providing common functions for the technical
# analysis of financial market data. It contains over 130 TA indicators and
# offers candlestick pattern recognition.
# .
# This package contains some tools for this library.
