=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
# export DH_VERBOSE=1
#export DEB_BUILD_OPTIONS=nocheck
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ --with autoreconf

override_dh_auto_test:
	# there is no other test available, run this
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	./src/tools/ta_regtest/ta_regtest
endif

override_dh_auto_install:
	dh_auto_install
	find
