=== debian/tests/control ===
Tests: testlib
Depends: ta-lib-dev
