=== debian/watch ===
version=4
https://github.com/TA-LIB/ta-lib/tags .*/v?(\d.*)@ARCHIVE_EXT@ debian uupdate
